﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;

namespace MVVMTutorial.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class LoginService
    {
        /// <summary>
        /// 简单的记录校验码，为简单起见，认为校验码永久有效
        /// </summary>
        private static List<string> validationCodes = new List<string>();

        /// <summary>
        /// 生成简单的校验码
        /// </summary>
        /// <returns></returns>
        [OperationContract]
        public string GenerateValidationCode()
        {
            string ticks = DateTime.Now.Ticks.ToString();
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            for (int i = ticks.Length - 5; i >= ticks.Length - 8; i--)
            {
                sb.Append(ticks[i]);
            }
            if (!validationCodes.Contains(sb.ToString()))
            {
                validationCodes.Add(sb.ToString());
            }
            return sb.ToString();
        }

        /// <summary>
        /// 简单登录判断
        /// </summary>
        /// <param name="usr"></param>
        /// <param name="validationCode"></param>
        /// <returns>1：用户名密码正确；0：用户名密码不正确；2：校验码无效</returns>
        [OperationContract]
        public short Login(Models.User usr , string validationCode)
        {
            if (!validationCodes.Contains(validationCode))
            {
                return 2;
            }
            if (usr != null && usr.UserName.ToLower() == "test" && usr.Password == "test")
            {
                return 1;
            }
            else
            {
                return 0;
            }
        }
    }
}
