﻿using System;
using System.Runtime.Serialization;
using System.ComponentModel.DataAnnotations;

namespace MVVMTutorial.Web.Models
{
    /// <summary>
    /// 此 class 从 Reference.cs 中copy而来，
    /// 加上了 System.ComponentModel.DataAnnotations 中的各种 Attribute，
    /// 并且将 namespace 改为了和 WCF 中的相同 MVVMTutorial.Web.Models
    /// </summary>
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
    [System.Runtime.Serialization.DataContractAttribute(Name = "User", Namespace = "http://schemas.datacontract.org/2004/07/MVVMTutorial.Web.Models")]
    public partial class User : object, System.ComponentModel.INotifyPropertyChanged
    {

        private string PasswordField;

        private string UserNameField;

        [Required]
        [StringLength(6,MinimumLength=3)]
        [Display(Name="密码",Description="区分大小写")]
        [System.Runtime.Serialization.DataMemberAttribute()]
        public string Password
        {
            get
            {
                return this.PasswordField;
            }
            set
            {
                if ((object.ReferenceEquals(this.PasswordField, value) != true))
                {
                    this.ValidateProperty("Password", value);
                    this.PasswordField = value;
                    this.RaisePropertyChanged("Password");
                }
            }
        }

        [Required]
        [StringLength(6, MinimumLength = 3)]
        [Display(Name = "用户名", Description = "不区分大小写")]
        [RegularExpression("^[a-zA-Z0-9\\-_.]*$", ErrorMessage = "只能输入字母、数字-_.")]
        [System.Runtime.Serialization.DataMemberAttribute()]
        public string UserName
        {
            get
            {
                return this.UserNameField;
            }
            set
            {
                if ((object.ReferenceEquals(this.UserNameField, value) != true))
                {
                    this.ValidateProperty("UserName", value);
                    this.UserNameField = value;
                    this.RaisePropertyChanged("UserName");
                }
            }
        }

        protected void ValidateProperty(string memberName, object value)
        {
            Validator.ValidateProperty(value, new ValidationContext(this, null, null) { MemberName = memberName });
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
            }
        }
    }
 
}
