﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace MVVMTutorial.ViewModels
{
    /// <summary>
    /// 使用 Action<Object> 作为通用的 Command，如果要使用 Action<T> 的其他形式，则要创建新的类型。
    /// 使用 struct 从 Heap 中进行存储，性能更高
    /// </summary>
    public struct ViewModelCommand : ICommand
    {
        private Action<Object> action;
        public Action<Object> ViewModelAction
        {
            get { return action; }
            set { action = value; }
        }

        public ViewModelCommand(Action<Object> act)
        {
            action = act;
        }

        public bool CanExecute(Object parameter)
        {
            return true;
        }
        public void Execute(Object parameter)
        {
            this.ViewModelAction(parameter);
        }
        public event EventHandler CanExecuteChanged
        {
            add { }
            remove { }
        }
    }
}
