﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using MVVMTutorial.ViewModels;
using MVVMTutorial.Helpers;


namespace MVVMTutorial.Views
{
    public partial class LoginPage : Page
    {
        LoginViewModel loginVM;

        public LoginPage()
        {
            InitializeComponent();
            this.loginVM = new LoginViewModel()
            {
                ValidationSummary = this.validationSummary1,
                ValidationUICollection = this.LayoutRoot.Children
            };
            this.loginVM.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(loginVM_PropertyChanged);
            this.Loaded+=new RoutedEventHandler(LoginPage_Loaded);
        }

        void loginVM_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "IsDone")
            {
                if (this.loginVM.IsDone)
                {
                    // 登录成功，执行跳转
                }
            }
            else if (e.PropertyName == "Message")
            {
                // 可以在 UI 上将 Message 也和 TextBlock 等进行绑定，以显示消息
                MessageBox.Show(this.loginVM.Message);
            }
        }

        void LoginPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.loginVM.GenerateValidationCodeAsync();
            this.DataContext = this.loginVM;
        }

    }
}
