﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace MVVMTutorial.Helpers
{
    public static class SLExtensions
    {
        /// <summary>
        /// 对集合中的 TextBox 等调用UpdateSource()方法，以校验数据源
        /// </summary>
        /// <param name="uiCollection"></param>
        public static void ValidateSource(this UIElementCollection uiCollection)
        {
            foreach (UIElement uie in uiCollection)
            {
                if (uie is TextBox)
                {
                    ((TextBox)uie).ValidateSource();
                }
                else if (uie is PasswordBox)
                {
                    ((PasswordBox)uie).ValidateSource();
                }
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="textBox"></param>
        public static void ValidateSource(this TextBox textBox)
        {
            System.Windows.Data.BindingExpression binding = textBox.GetBindingExpression(TextBox.TextProperty);
            if (binding != null)
            {
                binding.UpdateSource();
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="pwdBox"></param>
        public static void ValidateSource(this PasswordBox pwdBox)
        {
            System.Windows.Data.BindingExpression binding = pwdBox.GetBindingExpression(PasswordBox.PasswordProperty);
            if (binding != null)
            {
                binding.UpdateSource();
            }
        }
    }
}
