﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using MVVMTutorial.ViewModels;
using MVVMTutorial.Helpers;


namespace MVVMTutorial.Views
{
    public partial class LoginPage : Page
    {
        LoginViewModel loginVM;

        public LoginPage()
        {
            InitializeComponent();
            this.loginVM = new LoginViewModel();
            this.loginVM.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(loginVM_PropertyChanged);
            this.Loaded+=new RoutedEventHandler(LoginPage_Loaded);
        }

        void loginVM_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "IsDone")
            {
                if (this.loginVM.IsDone)
                {
                    // 登录成功，执行跳转
                }
            }
            else if (e.PropertyName == "Message")
            {
                // 可以在 UI 上将 Message 也和 TextBlock 等进行绑定，以显示消息
                MessageBox.Show(this.loginVM.Message);
            }
        }


        void LoginPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.loginVM.GenerateValidationCodeAsync();
            this.DataContext = this.loginVM;
        }

        private void btnChangeValidationCode_Click(object sender, RoutedEventArgs e)
        {
            this.loginVM.GenerateValidationCodeAsync();
        }

        // 对 validationSummary1 进行判断的这段代码是否该移入 ViewModel 中？
        // 如果移进去了，则会造成 ViewModel 依赖于 UI，
        // 如果仅是把 validationSummary1、LayoutRoot 作为参数传递，对于复杂的UI，可能要传递多个这样的参数
        private void btnLogin_Click(object sender, RoutedEventArgs e)
        {
            if (this.validationSummary1.HasErrors)
            {
                this.validationSummary1.Focus();
                return;
            }
            else
            {
                // 扩展方法，校验各个控件的数据绑定
                this.LayoutRoot.Children.ValidateSource();
                if (this.validationSummary1.HasErrors)
                {
                    this.validationSummary1.Focus();
                    return;
                }
            }

            this.loginVM.LoginAsync();
        }
    }
}
